package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.utils;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.net.URLDecoder;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import javax.crypto.spec.IvParameterSpec;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.iov.sjjh.commons.lang.PatternTools;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.vo.LocationCheckQuestResponseObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.vo.LocationRequestObject;
import lombok.extern.slf4j.Slf4j;
@Slf4j
@Component
public class LocationUtil {
	@Autowired
	LocationSupplierProperties locationSupplierProperties;
	@Autowired
	private ObjectMapper objectMapper;

		public  String calculateParam(Object object) {
			try {
				Class cls = object.getClass();
				Field[] fields = cls.getDeclaredFields();
				String params = "";
				StringBuffer sbf = new StringBuffer();
				for (Field field : fields) {
					String fieldName = field.getName();
					Method method = cls.getMethod("get" + fieldName.substring(0, 1).toUpperCase() + fieldName.substring(1));
					String value = (String) method.invoke(object);
					if(value!=null){
						value = URLDecoder.decode(value, "utf-8");
						sbf.append(fieldName).append("=").append(value).append("&");
					}
					
				}
				if (sbf.length() != 0) {
					sbf = sbf.delete(sbf.length() - 1, sbf.length());
					log.info("加密之前:{}",sbf);
				   params = encodeString(sbf.toString(), locationSupplierProperties.getSecret());
				   log.info("加密之后:{}",params);
				}
				return params;
			} catch (Exception ex) {
				log.error("计算签名错误:{}", ex);
			}
			return "";
		}
		public boolean checkLocationParm(LocationRequestObject requestObject){
			String phone = requestObject.getPhone();
			String imei = requestObject.getImei();
			boolean flag = false;
			if (StringUtils.isBlank(phone) && StringUtils.isBlank(imei)) {
				flag = true;
			} else if (StringUtils.isBlank(requestObject.getLongitude())
					&& StringUtils.isBlank(requestObject.getLatitude())
					&& StringUtils.isBlank(requestObject.getAddress())) {
				log.debug("");
				flag = true;
			} else if (!locationSupplierProperties.getAddrType().contains(requestObject.getAddrType())) {
				flag = true;
			}
			return flag;
		}
		public void locationCodeCheck(ChannelTypeHandleResponseObject ret,LocationCheckQuestResponseObject responseObject) throws JsonProcessingException{
			String upstreamCode = responseObject.getCode();
			if("0".equals(upstreamCode)){
				if("1".equals(responseObject.getData().getIsMatch())){
					ret.setCode(Constant.SUCCESS);
					ret.setResultCode(Constant.MATCH_CODE);
					ret.setResultBody(objectMapper.writeValueAsString(responseObject.getData()));
					ret.setIsCharge(1);
				}else{
					ret.setCode(Constant.SUCCESS);
					ret.setResultCode(Constant.UN_MATCH_CODE);
					ret.setResultBody(Constant.UN_MATCH);
				}
			}else if("200".equals(upstreamCode)){
				ret.setCode(Constant.SUCCESS);
				ret.setResultCode(Constant.UN_FIND_NUM_CODE);
				ret.setResultBody(Constant.UN_FIND_NUM);
			}else if("205".equals(upstreamCode)){
				ret.setCode(Constant.SUCCESS);
				ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
				ret.setResultBody(Constant.INVALID_PARAMETER);
			}else{
				ret.setCode(Constant.SUCCESS);
				ret.setResultCode(Constant.OTHER_ERROR_CODE);
				ret.setResultBody(Constant.OTHER_ERROR);
			}
		}
		public static String encodeString(String str,String secret)  {
	    	try{
	    		DESKeySpec deskey = new DESKeySpec(secret.getBytes("UTF-8"));
	    		SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
	    		SecretKey secretKey = keyFactory.generateSecret(deskey);
	    		Cipher cipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
	    		IvParameterSpec iv = new IvParameterSpec(secret.getBytes("UTF-8"));
	    		cipher.init(Cipher.ENCRYPT_MODE, secretKey, iv);
	    		return new sun.misc.BASE64Encoder().encode(cipher.doFinal(str.getBytes("utf-8")));
	    	} catch (Exception e) {
               log.error("DESUtil encodeString,message:{}",e);
            }
	    	return "";

}
	      
}
